/* nalloc.c */
/* $Id$ */

#include "externs.h"

static void *glurp=0;
static int glurpsize=0;
static int glurppos=0;

struct oldglurp {
  void *ptr;
  struct oldglurp *next;
} *olds = NULL;

static void biggerglurp(line, file)
     int line;
     char *file;
{
  if (!glurp) {
    glurp = malloc(4096);
    glurpsize = 4096;
    return;
  } else {
    struct oldglurp *o;
    void *oldglurp;
    char buf[1024];

    glurpsize *= 2;
    glurppos = 0;

    oldglurp = glurp;
    glurp = malloc(glurpsize);

    sprintf(buf,"doubling glurp size to %d (%s:%d)",glurpsize,file,line);
    log_io(buf);
    o = newglurp(sizeof(struct oldglurp));
    o->next = olds;
    o->ptr = oldglurp;
    olds = o;
  }
}

void *newglurp_fil(size, line, file)
     int size;
     int line;
     char *file;
{
  size = (size+7)/8;
  if (size<=0) size = 1;
  size *= 8;
  while (glurppos+size > glurpsize)
    biggerglurp(line, file);
  glurppos += size;
  return (void *)(((char *)glurp) + (glurppos-size));
}

void clearglurp()
{
  glurppos = 0;			/* that was easy. */
  if (olds) {
    /* darn, we have to clean these ones out. */
    for (; olds; olds=olds->next) {
      /* this is safe to do, as each old is always allocated in the block after it. */
      free(olds->ptr);
    }
  }
}

char *glurpdup(s)
     char *s;
{
  char *op;
  op = newglurp(strlen(s)+1);
  strcpy(op,s);
  return op;
}

